
import { _decorator, Component, Prefab, Node, NodePool, instantiate, Canvas } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('Main')
export class Main extends Component {
    // [1]
    // dummy = '';

    // [2]
    // @property
    // serializableDummy = 0;
    @property(Prefab)
    private roleVoPf: Prefab = null;//人物显示节点预制体
    pool: NodePool = new NodePool();

    @property(Node)
    private layer: Node = null;

    private dragNode: Node;
    start() {

        this.dragNode = this.pool.get() || instantiate(this.roleVoPf);

        this.dragNode.parent = this.layer;
    }

    private sum = 0;
    update(deltaTime: number) {
        this.sum += deltaTime;

        if (this.sum > 5) {
            this.sum = 0;
            if (this.dragNode) {
                this.pool.put(this.dragNode);
                this.dragNode = null;

            } else {
                this.dragNode = this.pool.get() || instantiate(this.roleVoPf);
                this.dragNode.parent = this.layer;
            }

        }
    }
}

/**
 * [1] Class member could be defined like this.
 * [2] Use `property` decorator if your want the member to be serializable.
 * [3] Your initialization goes here.
 * [4] Your update function goes here.
 *
 * Learn more about scripting: https://docs.cocos.com/creator/3.0/manual/en/scripting/
 * Learn more about CCClass: https://docs.cocos.com/creator/3.0/manual/en/scripting/ccclass.html
 * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.0/manual/en/scripting/life-cycle-callbacks.html
 */
